org.apache.xpath.axes

## Class FilterExprWalker

- java.lang.Object
- - org.apache.xpath.Expression
  - - org.apache.xpath.patterns.NodeTest
    - - org.apache.xpath.axes.PredicatedNodeTest
      - - org.apache.xpath.axes.AxesWalker
        - - org.apache.xpath.axes.FilterExprWalker

- All Implemented Interfaces:
    java.io.Serializable, java.lang.Cloneable, javax.xml.transform.SourceLocator, PathComponent, SubContextList, ExpressionNode, ExpressionOwner, XPathVisitable

      public class FilterExprWalker
      extends AxesWalker

  Walker for the OP_VARIABLE, or OP_EXTFUNCTION, or OP_FUNCTION, or OP_GROUP, op codes.
  See Also:
    XPath FilterExpr descriptions, Serialized Form

- - ### Field Summary

    - ### Fields inherited from class org.apache.xpath.patterns.NodeTest

      `SCORE_NODETEST, SCORE_NONE, SCORE_NSWILD, SCORE_OTHER, SCORE_QNAME, SHOW_BYFUNCTION, SUPPORTS_PRE_STRIPPING, WILD`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `FilterExprWalker(WalkingIterator locPathIterator)` Construct a FilterExprWalker using a LocPathIterator.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `short` | `acceptNode(int n)` This method needs to override AxesWalker.acceptNode because FilterExprWalkers don't need to, and shouldn't, do a node test.
    `void` | `callPredicateVisitors(XPathVisitor visitor)` This will traverse the heararchy, calling the visitor for each member.
    `java.lang.Object` | `clone()` Get a cloned FilterExprWalker.
    `boolean` | `deepEquals(Expression expr)` Compare this object with another object and see if they are equal, include the sub heararchy.
    `void` | `detach()` Detaches the walker from the set which it iterated over, releasing any computational resources and placing the iterator in the INVALID state.
    `void` | `fixupVariables(java.util.Vector vars, int globalsSize)` This function is used to fixup variables from QNames to stack frame indexes at stylesheet build time.
    `int` | `getAnalysisBits()` Get the analysis bits for this walker, as defined in the WalkerFactory.
    `int` | `getAxis()` Returns the axis being iterated, if it is known.
    `Expression` | `getInnerExpression()` Get the inner contained expression of this filter.
    `int` | `getLastPos(XPathContext xctxt)` Get the index of the last node that can be itterated to.
    `int` | `getNextNode()` Moves the `TreeWalker` to the next visible node in document order relative to the current node, and returns the new node.
    `void` | `init(Compiler compiler, int opPos, int stepType)` Init a FilterExprWalker.
    `boolean` | `isDocOrdered()` Returns true if all the nodes in the iteration well be returned in document order.
    `void` | `setInnerExpression(Expression expr)` Set the inner contained expression of this filter.
    `void` | `setRoot(int root)` Set the root node of the TreeWalker.

    - ### Methods inherited from class org.apache.xpath.axes.AxesWalker

      `callVisitors, getCurrentNode, getDTM, getExpression, getNextWalker, getPrevWalker, getRoot, nextNode, setDefaultDTM, setExpression, setNextWalker, setPrevWalker, wi`

    - ### Methods inherited from class org.apache.xpath.axes.PredicatedNodeTest

      `canTraverseOutsideSubtree, getLocPathIterator, getPredicate, getPredicateCount, getPredicateIndex, getProximityPosition, getProximityPosition, initProximityPosition, isReverseAxes, resetProximityPositions, setLocPathIterator, setPredicateCount`

    - ### Methods inherited from class org.apache.xpath.patterns.NodeTest

      `debugWhatToShow, execute, execute, execute, getDefaultScore, getLocalName, getNamespace, getNodeTypeTest, getStaticScore, getWhatToShow, initNodeTest, initNodeTest, setLocalName, setNamespace, setStaticScore, setWhatToShow`

    - ### Methods inherited from class org.apache.xpath.Expression

      `asIterator, asIteratorRaw, asNode, assertion, bool, error, execute, executeCharsToContentHandler, exprAddChild, exprGetChild, exprGetNumChildren, exprGetParent, exprSetParent, getColumnNumber, getExpressionOwner, getLineNumber, getPublicId, getSystemId, isNodesetExpr, isStableNumber, num, warn, xstr`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### FilterExprWalker

          public FilterExprWalker(WalkingIterator locPathIterator)

      Construct a FilterExprWalker using a LocPathIterator.
      Parameters:
        `locPathIterator` - non-null reference to the parent iterator.

  - ### Method Detail

    - #### init

          public void init(Compiler compiler,
                           int opPos,
                           int stepType)
                    throws javax.xml.transform.TransformerException

      Init a FilterExprWalker.
      Overrides:
        `init` in class `AxesWalker`
      Parameters:
        `compiler` - non-null reference to the Compiler that is constructing.
        `opPos` - positive opcode position for this step.
        `stepType` - The type of step.
      Throws:
        `javax.xml.transform.TransformerException`

    - #### detach

          public void detach()

      Detaches the walker from the set which it iterated over, releasing any computational resources and placing the iterator in the INVALID state.
      Overrides:
        `detach` in class `AxesWalker`

    - #### setRoot

          public void setRoot(int root)

      Set the root node of the TreeWalker.
      Overrides:
        `setRoot` in class `AxesWalker`
      Parameters:
        `root` - non-null reference to the root, or starting point of the query.

    - #### clone

          public java.lang.Object clone()
                                 throws java.lang.CloneNotSupportedException

      Get a cloned FilterExprWalker.
      Overrides:
        `clone` in class `AxesWalker`
      Returns:
        A new FilterExprWalker that can be used without mutating this one.
      Throws:
        `java.lang.CloneNotSupportedException`

    - #### acceptNode

          public short acceptNode(int n)

      This method needs to override AxesWalker.acceptNode because FilterExprWalkers don't need to, and shouldn't, do a node test.
      Overrides:
        `acceptNode` in class `PredicatedNodeTest`
      Parameters:
        `n` - The node to check to see if it passes the filter or not.
      Returns:
        a constant to determine whether the node is accepted, rejected, or skipped, as defined above .

    - #### getNextNode

          public int getNextNode()

      Moves the `TreeWalker` to the next visible node in document order relative to the current node, and returns the new node. If the current node has no next node, or if the search for nextNode attempts to step upward from the TreeWalker's root node, returns `null` , and retains the current node.
      Returns:
        The new node, or `null` if the current node has no next node in the TreeWalker's logical view.

    - #### getLastPos

          public int getLastPos(XPathContext xctxt)

      Get the index of the last node that can be itterated to.
      Specified by:
        `getLastPos` in interface `SubContextList`
      Overrides:
        `getLastPos` in class `AxesWalker`
      Parameters:
        `xctxt` - XPath runtime context.
      Returns:
        the index of the last node that can be itterated to.

    - #### fixupVariables

          public void fixupVariables(java.util.Vector vars,
                                     int globalsSize)

      This function is used to fixup variables from QNames to stack frame indexes at stylesheet build time.
      Overrides:
        `fixupVariables` in class `PredicatedNodeTest`
      Parameters:
        `vars` - List of QNames that correspond to variables. This list should be searched backwards for the first qualified name that corresponds to the variable reference qname. The position of the QName in the vector from the start of the vector will be its position in the stack frame (but variables above the globalsTop value will need to be offset to the current stack frame).

    - #### getInnerExpression

          public Expression getInnerExpression()

      Get the inner contained expression of this filter.

    - #### setInnerExpression

          public void setInnerExpression(Expression expr)

      Set the inner contained expression of this filter.

    - #### getAnalysisBits

          public int getAnalysisBits()

      Get the analysis bits for this walker, as defined in the WalkerFactory.
      Specified by:
        `getAnalysisBits` in interface `PathComponent`
      Overrides:
        `getAnalysisBits` in class `AxesWalker`
      Returns:
        One of WalkerFactory#BIT_DESCENDANT, etc.

    - #### isDocOrdered

          public boolean isDocOrdered()

      Returns true if all the nodes in the iteration well be returned in document order. Warning: This can only be called after setRoot has been called!
      Overrides:
        `isDocOrdered` in class `AxesWalker`
      Returns:
        true as a default.

    - #### getAxis

          public int getAxis()

      Returns the axis being iterated, if it is known.
      Overrides:
        `getAxis` in class `AxesWalker`
      Returns:
        Axis.CHILD, etc., or -1 if the axis is not known or is of multiple types.

    - #### callPredicateVisitors

          public void callPredicateVisitors(XPathVisitor visitor)

      This will traverse the heararchy, calling the visitor for each member. If the called visitor method returns false, the subtree should not be called.
      Overrides:
        `callPredicateVisitors` in class `PredicatedNodeTest`
      Parameters:
        `visitor` - The visitor whose appropriate method will be called.

    - #### deepEquals

          public boolean deepEquals(Expression expr)

      Description copied from class: `Expression`
      Compare this object with another object and see if they are equal, include the sub heararchy.
      Overrides:
        `deepEquals` in class `AxesWalker`
      Parameters:
        `expr` - Another expression object.
      Returns:
        true if this objects class and the expr object's class are the same, and the data contained within both objects are considered equal.
      See Also:
        `Expression.deepEquals(Expression)`

Copyright © 2023 Apache XML Project. All Rights Reserved.